﻿///<reference name="MicrosoftAjax.js">
/*================================================================
version: 1.0.0.0 build 
Copyright 2008 by Ravello Software, LLC
For more information, see:www.RavelloAnalytics.com
================================================================*/
//page pre-unload warning
//window.onbeforeunload = pageTerminateWarning

//note: when results save and upload capabilities are added, these counters will need to start at something other than zero
    var rowId_s=0, rowId_sd=1, rowId_ris=1, rowId_rid=1, rowId_hw=1, rowId_sw=1, rowId_si=1;  //use base 1 (potential conflict with 0 in dhmtlx controls - logical false is also 0)
//global varibles for inputs that need to be formed as array
    var capInitialProcessorNbr = new Array(), capInitialProcessorScalar = new Array(), capInitialProcessorSetSize = new Array(), capInitialProcessorCoreSetSize = new Array();
    var currentSwLicCostCore = new Array(), currentSwLicCostCoreFactor = new Array(), currentSwLicMaintCostCore = new Array();
//set data source name for chart data source based upon user menu selection 
    var grdProcessName_sd = null, grdProcessName_ris = null;
//set to null as default for passing to RavelloModel
    var targetReplaceTime = null;
//set as default
    var replacementQueue = 0;
//summary base and comparison scenario selection
    var br = null;     //selected base row id 
    var cr = null;     //selected comparison row id
//global scope of JSON return variable
    var returnJSON;
//global scope for asyncSetChart interval clear
    var grdSource;
    
//a rounding function
function roundNumber(num, dec) {
        var result = Math.round(num * Math.pow(10, dec)) / Math.pow(10, dec);
        return result;
}
function pageTerminateWarning() {
   return 'All scenarios will be permanently lost if you have not saved the results.';
}
function doInitControls() {
   
    doInitPrimaryLayout();
    doInitMenu();
/*
    doInitAccordian();
    doInitBar();
    doInitTbr();   //tabbar
    doInitGrids();
    doInitCombo();
    doInitChart();
    doInitWindows();
   
    //check if user already logged in and authorized
    isUserLoggedIn("pl");
*/
}
/*
//complete handler for web service message reply
function onRavelloModelComplete(result) {

    //alert("pre-deserialized: " + result);
    returnJSON = Sys.Serialization.JavaScriptSerializer.deserialize(result);
    //alert("deserialized: " + r);

    if (returnJSON.ReplySummary[0] == "errListRavello") {
        //alert("Data entry error(s)")
        postReplyErrMsg(returnJSON);
        
    }
    else {
        document.getElementById("error_summary").innerHTML = "";
        accordMn.cells("a8").hide();
        accordMn.cells("a8").close();
        loadReplyArray_s(returnJSON);

        //load scenario input variables into grid/tabbar in asynchronous manner because of slow performance
        var t_sd = setTimeout("loadReplyArray_sd(returnJSON)", 1);
        var t_ris = setTimeout("loadReplyArray_ris(returnJSON)", 1);
        var t_rid = setTimeout("loadReplyArray_rid(returnJSON)", 1);
        var t_si = setTimeout("addScenarioInputRows(rowId_s)", 1);


        //delay call to setChart() until the proper grid is populated
        var grdDataSourceName = getChartDataSource();
        grdSource = setInterval(function() {
            if (grdDataSourceName == grdProcessName_sd | grdProcessName_ris) {
                setChart();
                grdProcessName = null;
                clearInterval(grdSource);
            }
        }, 100);
        if (br == 1) { enableDeleteScenarioMenuItems();enableReportPrintPreview(); }
        if (cr != null) { enableClearComparisonMenuItem(); } else { disableClearComparisonMenuItem(); }
     }
     if (br != null) { showResultsLayout(); }
}
//error handler for model web service
function onRavelloModelFailure(error_object, userContext, methodName) {
    alert("Fetch Authenticated User failed with this error: " +
	    error_object.get_message());
}

function validateCbxInitInvPurchasedSetting() {
    if ($get("cbxIncludeMfExistInv").checked == true) { $get("cbxInitInvPurchased").checked = false; }
    
}
function validateCbxIncludeMfExistInv() {
    if ($get("cbxInitInvPurchased").checked == true) { $get("cbxIncludeMfExistInv").checked = false; }
}

function doAddServerInventory() {
    grd_hw.addRow(rowId_hw, ",,,", 0); 
    rowId_hw++;
    doAddSoftwareLicenseKeyToHwInvItemComboBox(); 
}
function doDeleteServerInventory(selRowId){
    if (!isNaN(selRowId)) {
        grd_hw.deleteRow(selRowId);
        grd_hw.selectRow(0, false, false, false); 
    }
}

function doAddLicenseTerms() {
    var i = rowId_sw + ",,,,,";
    grd_sw.addRow(rowId_sw, i.toString(), 0);
    grd_sw.cells(rowId_sw, 4).setValue(0);
    grd_sw.cells(rowId_sw, 5).setValue(0);
    //grd_sw.setCellExcellType(rowId_sw, 5, "edn");
    rowId_sw++;

    //$get("comboFutSwLicTerms").disabled = false;
    //document.getElementById("comboFutSwLicTerms").setAttribute().disabled = false;
}
function doDeleteLicenseTerms(selRowId) {
    if (!isNaN(selRowId)) {
        doDeleteLicenseTermsFromHwLineItem(selRowId);
        grd_sw.deleteRow(selRowId);
        grd_sw.selectRow(0, false, false, false);
        //set disable
        var arrValid = displayOnlyValidLicIds();
        if (arrValid.length == 0) {
            doOnActiveAccordian("a5");
        } 
    }
}

function doDeleteLicenseTermsFromHwLineItem(itemId) {
    //delete the sw license id from any reference in hw inventory 
    grd_hw.forEachRow(function(id) {
        var c = grd_hw.cells(id, 4).getValue();
        var a = c.split(",");
        var nc = new Array(); var p = 0;
        for (var i = 0; i < a.length; i++) {
            if (itemId != a[i]) { nc[p] = a[i]; p++; }
        }
        grd_hw.cells(id, 4).setValue(nc.toString());
    });
}

function showSelectedRow(rowId, visibility) {
    //the called functions are nested to run asynchronously 
    //have changed to hide/show rows by directly changing DOM instead of using API
    showSelectedRow_sd(rowId, visibility);
    showSelectedRow_ris(rowId, visibility);
    showSelectedRow_rid(rowId, visibility);
    showSelectedRow_si(rowId, visibility);
}
 
function showSelectedRow_sd(rowId, visibility) {
     function show_sd() {
         if (visibility == false) {
             grd_sd.forEachRow(function(id) {
             if (grd_sd.cells(id, 0).getValue() == rowId) { grd_sd.rowsAr[id].style.display = '';}  // grd_sd.setRowHidden(id, false); }
             else { grd_sd.rowsAr[id].style.display = 'none';} // grd_sd.setRowHidden(id, true); }
             })
             grd_sd.setColumnHidden(0, true);
         }
         else {
             grd_sd.forEachRow(function(id) {
                grd_sd.rowsAr[id].style.display = '';  // grd_sd.setRowHidden(id, false);
             })
             grd_sd.setColumnHidden(0, false);
         }
     }
     var t = setTimeout(show_sd, 1); 
 }
 function showSelectedRow_ris(rowId, visibility) {
     function show_ris() {
         if (visibility == false) {
             grd_ris.forEachRow(function(id) {
             if (grd_ris.cells(id, 0).getValue() == rowId) {  grd_ris.rowsAr[id].style.display = ''; } //grd_ris.setRowHidden(id, false); }
             else {  grd_ris.rowsAr[id].style.display = 'none'; } //grd_ris.setRowHidden(id, true); }
             })
             grd_ris.setColumnHidden(0, true);
         }
         else {
             grd_ris.forEachRow(function(id) {
               grd_ris.rowsAr[id].style.display = ''; // grd_ris.setRowHidden(id, false);
             })
             grd_ris.setColumnHidden(0, false);
         }
     }
     var t = setTimeout(show_ris, 1);
}
function showSelectedRow_rid(rowId, visibility) {
    function show_rid() {
        if (visibility == false) {
            grd_rid.forEachRow(function(id) {
                if (grd_rid.cells(id, 0).getValue() == rowId) { grd_rid.rowsAr[id].style.display = '';} //{ grd_rid.setRowHidden(id, false); }
                else { grd_rid.rowsAr[id].style.display = 'none'; } // { grd_rid.setRowHidden(id, true); }
            })
            grd_rid.setColumnHidden(0, true);
        }
        else {
            grd_rid.forEachRow(function(id) {
                grd_rid.setRowHidden(id, false);
            })
            grd_rid.setColumnHidden(0, false);
        }
    }
    var t = setTimeout(show_rid, 1);  
}
function showSelectedRow_si(rowId, visibility) {
    function show_si() {
        if (visibility == false) {
            grd_si.forEachRow(function(id) {
                if (grd_si.cells(id, 0).getValue() == rowId) { grd_si.rowsAr[id].style.display = '';} //{ grd_si.setRowHidden(id, false); }
                else { grd_si.rowsAr[id].style.display = 'none'; }  //{ grd_si.setRowHidden(id, true); }
            })
            grd_si.setColumnHidden(0, true);
        }
        else {
            grd_si.forEachRow(function(id) {
              grd_si.rowsAr[id].style.display = ''; // grd_si.setRowHidden(id, false);
            })
            grd_si.setColumnHidden(0, false);
        }
    }
    
    var t = setTimeout(show_si, 1);  
}











function postReplyErrMsg(r) {
    var errMsg = "<b>Please correct the following errors.</b><ul>";
    var l = r.ReplySummary.length;
    for(var i = 1; i < l; i++) { errMsg = errMsg + "<li>" + r.ReplySummary[i] + "</li>"; }
    errMsg = errMsg + "</ul>";
    $get("error_summary").innerHTML = errMsg;
    accordMn.cells("a8").show();
    accordMn.cells("a8").open();
}

function loadReplyArray_s(r) {
    //summary record
    var rso = new Object();
    rso = r.ReplySummary[0];
    var rs = new Array(), i = 0;
    for (var prop in rso) {
        rs[i] = rso[prop];
        i++;
    }
    addSummaryRow(rs);
}

function addSummaryRow(reply) {
    var simName = document.getElementById("tbxSimName").value;

    //var simName = document.getElementById("ctl07_tbxSimName").value;
    rowId_s++;
    reply.splice(0, 1, "1", "0", rowId_s, simName); //scenario id uses base 1 (for user) 
    grd_s.addRow(rowId_s, reply, 0);  //row id also uses base 1 because of type conflict (0 can also be a logical false)
    br = rowId_s;
    //rowId_s++; 
    //setPageAreaVisibility();
    SetGrd_s_BaseColors(rowId_s);
}

function loadReplyArray_sd(r) {
    //interval summary detail records
    var l = r.ReplySummaryDetail.length, sd = new Array(l);
    for (var i = 0; i < l; i++) {
        var _rd = new Array(), j = 0, rsd = new Object();
        rsd = r.ReplySummaryDetail[i];
        _rd[j] = rowId_s;
        for (var prop in rsd) {
            //skip first item because of unique _Type property passed by MS
            if (j > 0)
            { _rd[j] = rsd[prop]; }
            j++;
        }
        sd[i] = _rd;
    }
    //this function located in aspx page
    addSumDetailRows(sd);
    showSelectedRow_sd(rowId_s, isDetailGridsVisible);
}
function loadReplyArray_ris(r) {
    //inventory summary (by interval) records
    var l2 = r.ReplyInventorySummary.length, ris = new Array;
    for (var i = 0; i < l2; i++) {
        var _ris = new Array(), j = 0, riso = new Object();
        riso = r.ReplyInventorySummary[i];
        _ris[j] = rowId_s;
        for (var prop in riso) {
            //skip first item because of unique _Type property passed by MS
            if (j > 0)
            { _ris[j] = riso[prop]; }
            j++;
        }
        ris[i] = _ris;
    }
    addInvSummaryRows(ris);
    showSelectedRow_ris(rowId_s, isDetailGridsVisible);
}
function loadReplyArray_rid(r){
    //inventory detail records
    //alert("pre-detail inv load: ");
    var l3 = r.ReplyInventoryDetail.length, rid = new Array;
    for (var i = 0; i < l3; i++) 
    {
        var _rid = new Array(), j = 0, risd = new Object();
        risd = r.ReplyInventoryDetail[i];
        _rid[j] = rowId_s;
        for (var prop in risd) {
            //skip first item because of unique _Type property passed by MS
            if (j > 0)
            { _rid[j] = risd[prop]; }
            j++;
        }
        rid[i] = _rid;
    }
    addInvDetailRows(rid);
    showSelectedRow_rid(rowId_s, isDetailGridsVisible);
    addGrid_rRows(rowId_s);
    addGrd_aRows(); 
}
*/
/*
function webServiceCleanUp() {
//remove endRequest
//alert("Cleanup");
var prm = Sys.WebForms.PageRequestManager.getInstance();
prm.remove_endRequest(webService_RavelloModelResults);
}*/

/*
function pageLoad() {
var prm = Sys.WebForms.PageRequestManager.getInstance();
prm.add_endRequest(webService_RavelloModelResults);

//pageLoaded only occurs on a sync postback
//this will remove redundant callbacks (testWebService) 
//created by sync postback (works with IE, Firefox, Chrome)
Sys.WebForms.PageRequestManager.getInstance().add_pageLoaded(pageLoadedHandler);
}

function pageLoadedHandler() {
var prm = Sys.WebForms.PageRequestManager.getInstance();
prm.remove_endRequest(webService_RavelloModelResults);
}
*/
