﻿///<reference name="MicrosoftAjax.js">

/*================================================================
version: 1.0.0.0 build 
Copyright 2008 by Ravello Software, LLC
For more information, see:www.RavelloAnalytics.com
================================================================*/



//global variable menu
var mnuMn,  isDetailGridsVisible = false, isChartCompare = false, isShowFirstReplaceTransaction = true; isShowPaneAnalysis = true;

//global variable 
var chartSelection; //value is set based upon default 'true' setting in menu initilization and captured at end of rm_mnu.js";
//var reportSelection;

function mnuMn_onClick(id) {
    switch (id) {
        case "account_status":
            isUserLoggedIn("ws", doShowUserAccountInfo, "0");  //type, function, callback (no callback)
            break;
        case "change_email":
            isUserLoggedIn("ws", doShowEmailAddressChangeStep1, "0");  //type, function, callback (no callback)
            break;
        case "change_pswd":
            isUserLoggedIn("ws", doChangeUserPasswordWindow, "0");  //type, function, callback (no callback)
            break;
        case "change_security":
            doFetchSecurityQuestion();   //isUserLoggedIn executed on fetch of security answer
            break;
        case "guide_data_definitions":
            doGuideDataDefinitionsWindow();
            break;
        case "login":
            doLoginWindow();
            break;
        case "logout":
            doRavelloLogout();
            break;
        case "run_scenario":
            var ws = new webService_RavelloModelResults();
            var t = setTimeout(ws,1); // webService_RavelloModelResults, 1);
            break;
        case "delete_scenario":
            var selRowId = grd_s.getSelectedId()
            if (selRowId == null) {
                alert("A record needs to be selected.");
                return;
            }
            else { deleteRow_GridResult(selRowId); }
            break;
        case "clear_comparison":
            onClearComparisons();
            break;
        case "delete_all_scenarios":
            var r = deleteAll_GridResults();
            if (r == true) {
                hideResultsLayout();
                br = null;
                cr = null;
            }
            break;
        case "report_print_preview":
            doReport();
            break; 
    }
}

function mnuMn_onRadioClick(group, idChecked, idClicked) {

    //alert("ID is: " + idClicked + ", Group is: " + group);
    switch (group) {
        case "series_type":
            chartSelection = idClicked;
            //alert(chartSelection); 
            var t = setTimeout(setChart, 1);
            break;
        case "report_type":
            
            break;
    }
 }

function showFirstReplaceTransaction_onCheckboxClick(id, state) {
    isShowFirstReplaceTransaction = state;
    //alert("state is: " + state);
    //the state passed is pre-change at this time
    if (isShowFirstReplaceTransaction == false) { isShowFirstReplaceTransaction = true; } else { isShowFirstReplaceTransaction = false; }
    w_addGrid_rRows(br);
    return true;
}
function w_addGrid_rRows(br){
    //wrapper for async function required to pass args
    function doAddGrd_rRows() {
        addGrid_rRows(br);
    }
    var t = setTimeout(doAddGrd_rRows, 1); 
}

function showPaneAnalysis_onCheckboxClick(id, state) {
    isShowPaneAnalysis = state;
    if (isShowPaneAnalysis == false) {
        isShowPaneAnalysis = true;
        layoutMnSubB.cells("c").expand();
        layoutMnSubB.cells("c").hideHeader();
        //var t = setTimeout(grd_a.setSizes, 1);
    }
    else {
        isShowPaneAnalysis = false;
        layoutMnSubB.cells("c").showHeader();
        layoutMnSubB.cells("c").collapse();
        //var t = setTimeout(grd_a.setSizes, 1);
    }
    return true;
}

function grdDetailVisible_onCheckboxClick(id, state) {
    isDetailGridsVisible = state;
    //alert("state is: " + state);
    //the state passed is pre-change at this time
    if (isDetailGridsVisible == false) { isDetailGridsVisible = true; } else { isDetailGridsVisible = false; }
    //if (grd_s.getRowsNum() > 1) { var t = setTimeout(showSelectedRow, 1); }
    w_showSelectedRow(br, isDetailGridsVisible);
    
    return true;
}
function w_showSelectedRow(rowId, visibility) {
    //wrapper for async function required to pass args
    function doShowSelectedRow() {
        showSelectedRow(rowId, visibility); 
        }
        var t = setTimeout(doShowSelectedRow, 1);
}


function chart_onCheckboxClick(id, state) {
    //The STATE passed is pre-change at this time!!!!
    //first check is if a comparison scenario is selected
    if (cr == null && state == false)  //a scenario doesn't exist and the user is trying to change to comparison state
    {
        alert("A comparison scenario needs to be selected.");
        isChartCompare = false;
        mnuMn.setCheckboxState("compare_scenarios", isChartCompare); 
        return false;
    }
    //alert(id + " was clicked.  The state is: " + state);
    
    if (state == false) { isChartCompare = true; } else { isChartCompare = false; }
    chartSelection = id;
    setChart();
    return true;
}
function getChartDataSource() {
    //the expected data source for the selected chart presentation
    var idChecked = mnuMn.getRadioChecked("series_type");
    if (mnuMn.getParentId(idChecked) == "costs") { return "sd"; }
    return "ris";
}  
    
function doInitMenu() {
    mnuMn = new dhtmlXMenuObject("mnuMn", "dhx_black");
    mnuMn = layoutMn.cells("a").attachMenu();
   
   /* mnuMn = new dhtmlXMenuObject("mnuMain", "dhx_black");
    mnuMn = layoutMn.attachMenu();
   
    mnuMn.setImagePath("./dhx_controls/menu/codebase/imgs/");
    mnuMn.setIconsPath("./images/");
   
    mnuMn.attachEvent("onClick", function(id) {
    mnuMn_onClick(id)
    });
    mnuMn.attachEvent("onRadioClick", function(group, idChecked, idClicked) {
        mnuMn_onRadioClick(group, idChecked, idClicked);
        // return true to change state automatically
        return true;
    });
    mnuMn.attachEvent("onCheckboxClick", function(id, state, zoneId) {
        //alert("the state is: " + state);
        var rv;
        switch (id) {
            case "show_SelectScenario":
                rv = grdDetailVisible_onCheckboxClick(id, state);
                break;
            case "replace_transaction":
                rv = showFirstReplaceTransaction_onCheckboxClick(id, state);
                break;
            case "show_Grid_a":
                rv = showPaneAnalysis_onCheckboxClick(id, state);
                break;
            default:
                rv = chart_onCheckboxClick(id, state);
                break;
        }
        return rv;
    });
    


   mnuMn.addNewSibling(null, "login", "Sign in to your account...", false);
   mnuMn.addNewSibling("login", "file", "File", false);
        mnuMn.addNewChild("file", 0, "upload_hwInv", "Upload Hardware Inventory...", true, "open.gif");
        mnuMn.addNewChild("file", 1, "upload_swLic", "Upload Software Licenses...", true, "open.gif");
        mnuMn.addNewChild("file", 2, "logout", "Sign out", false, "logout1.png");
   mnuMn.addNewSibling("file", "view", "View", false);
        mnuMn.addNewChild("view", 0, "temp_1", "Place Holder", false);
        mnuMn.addCheckbox("sibling", "temp_1", null, "show_Grid_a", "Show Analysis Pane", true, false); 
    mnuMn.addNewSibling("view", "model", "Model", false);
        mnuMn.addNewChild("model", 0, "run_scenario", "Run Scenario", false, "run.png");
        mnuMn.addNewChild("model", 1, "delete_scenario", "Delete Scenario", true, "delete.png");
        mnuMn.addNewChild("model", 2, "delete_all_scenarios", "Delete All Scenarios", true);
        mnuMn.addNewChild("model", 3, "clear_comparison", "Clear Scenario Comparison", true);
        mnuMn.addNewSeparator("clear_comparison", "showSep", false);
        mnuMn.addCheckbox("sibling", "showSep", null, "show_SelectScenario", "All Scenario Details Visible", false, false);
        mnuMn.addCheckbox("sibling", "show_SelectScenario", null, "replace_transaction", "Show First Event with Replacement", true, false);
        mnuMn.addNewSeparator("delete_all_scenarios", "clearSep", false);
    mnuMn.addNewSibling("model", "report", "Reports", false);
        mnuMn.addNewChild("report", 0, "report_print_preview", "Print Preview", true, "print.gif");
        mnuMn.addRadioButton("sibling", "report_print_preview", null, "report_transaction", "Scenario Transaction Summary", "report_type", true, false);
        mnuMn.addRadioButton("sibling", "report_transaction", null, "report_detail", "Scenario Details", "report_type", false, false);
        mnuMn.addNewSeparator("report_print_preview", "reportSep", false);
        
    mnuMn.addNewSibling("report", "chart", "Charts", false);
    mnuMn.addNewChild("chart", 0, "chart_data","Chart Data...", false, "chart.png");
            mnuMn.addNewChild("chart_data", 0, "costs", "Costs...", false);
                mnuMn.addRadioButton("child", "costs", 0, "cost_cumtotalyr", "Cummulative Total per Year", "series_type", false, false);
                mnuMn.addRadioButton("child", "costs", 1, "cost_cumtotal", "Cummulative Total", "series_type", false, false);
                mnuMn.addRadioButton("child", "costs", 2, "cost_inctotal", "Incremental Total", "series_type", true, false);
                mnuMn.addRadioButton("child", "costs", 3, "cost_softmf", "Incremental Software Maintenance", "series_type", false, false);
                mnuMn.addRadioButton("child", "costs", 4, "cost_softlic", "Incremental Software License", "series_type", false, false);
                mnuMn.addRadioButton("child", "costs", 5, "cost_proc", "Incremental Processor", "series_type", false, false);
            mnuMn.addNewChild("chart_data", 1, "inventory", "Inventory...", false);
                mnuMn.addRadioButton("child", "inventory", 0, "cum_servers", "Cummulative Servers", "series_type", false, false);
                mnuMn.addRadioButton("child", "inventory", 1, "cum_processors", "Cummulative Processors", "series_type", false, false);
                mnuMn.addRadioButton("child", "inventory", 2, "cum_cores", "Cummulative Cores", "series_type", false, false);
                mnuMn.addRadioButton("child", "inventory", 3, "inc_servers", "Incremental Servers", "series_type", false, false);
                mnuMn.addRadioButton("child", "inventory", 4, "inc_processors", "Incremental Processors", "series_type", false, false);
                mnuMn.addRadioButton("child", "inventory", 5, "inc_cores", "Incremental Cores", "series_type", false, false);
            mnuMn.addNewChild("chart_data", 2, "capacity", "Capacity...", false);
                mnuMn.addRadioButton("child", "capacity", 0, "inc_capacity", "Incremental Total", "series_type", false, false);
                mnuMn.addRadioButton("child", "capacity", 1, "cum_capacity", "Cummulatative Total", "series_type", false, false);
                mnuMn.addRadioButton("child", "capacity", 2, "cum_cap_proc", "Cummulative Capacity per Processor", "series_type", false, false);
                mnuMn.addRadioButton("child", "capacity", 3, "cum_cap_core", "Cummulatative Capacity per Core", "series_type", false, false);
        mnuMn.addCheckbox("sibling", "chart_data", null, "compare_scenarios", "Compare Scenarios", false, false);
    mnuMn.addNewSibling("chart", "help", "Help", false);
        mnuMn.addNewChild("help", 0, "guide_use", "How to use...", false);
        mnuMn.addNewChild("help", 1, "guide_data_definitions", "Data Definitions...", false);
        mnuMn.addNewChild("help", 2, "guide_faq", "FAQ...", false);
        mnuMn.addNewChild("help", 3, "account_user", "Account...", false, "user_account.png");
            mnuMn.addNewChild("account_user", 0, "account_status", "Account Status...", false, "user_account_info.png");
            mnuMn.addNewChild("account_user", 1, "change_pswd", "Change Password...", false);
            mnuMn.addNewChild("account_user", 2, "change_email", "Change Email Address...", false);
            mnuMn.addNewChild("account_user", 3, "change_security", "Change Security Question/Answer...", false);
        mnuMn.addNewChild("help", 4, "about_r1", "About...", false);
        mnuMn.addNewSeparator("guide_faq", "guideSep", false);
        mnuMn.addNewSeparator("account_user", "accountSep", false);
        
    //hack to make View menu work with checkbox in first submenu
    mnuMn.setItemPosition("show_Grid_a", 0);
    mnuMn.setItemPosition("temp_1", 1);
    mnuMn.hideItem("temp_1");

    
    //set initial checkbox states
    mnuMn.setCheckboxState("show_Grid_a", isShowPaneAnalysis);
    mnuMn.setCheckboxState("show_SelectScenario", isDetailGridsVisible);
    mnuMn.setCheckboxState("compare_scenarios", isChartCompare);
    mnuMn.setCheckboxState("replace_transaction", isShowFirstReplaceTransaction);
    chartSelection = mnuMn.getRadioChecked("series_type");
    //    reportSelection = mnuMn.getRadioChecked("report_type");

    //determine what to show and hide
    showMenuOnUserAuthenticatedState();
*/
}

function enableDeleteScenarioMenuItems() {
    mnuMn.setItemEnabled("delete_scenario");
    mnuMn.setItemEnabled("delete_all_scenarios");
}
function enableClearComparisonMenuItem() {
    mnuMn.setItemEnabled("clear_comparison");
}
function disableClearComparisonMenuItem() {
    mnuMn.setItemDisabled("clear_comparison");
}
function disableDeleteScenarioMenuItems() {
    mnuMn.setItemDisabled("delete_scenario");
    mnuMn.setItemDisabled("delete_all_scenarios");
}
function enableReportPrintPreview() {
    mnuMn.setItemEnabled("report_print_preview");
}
function disableReportPrintPreview() {
    mnuMn.setItemDisabled("report_print_preview");
}

function doReport() {
   reportSelection = mnuMn.getRadioChecked("report_type");
   var h = constructReport(reportSelection);
   writeReport(h);
}
function showMenuOnUserAuthenticatedState() {
    if (ravelloIsUserAuthenticated == false) {
        //hide
        mnuMn.hideItem("file");
        mnuMn.hideItem("view");
        mnuMn.hideItem("model");
        mnuMn.hideItem("report");
        mnuMn.hideItem("chart");
        mnuMn.hideItem("help");
        //show
        mnuMn.showItem("login");
    }
    else {
        //hide
        mnuMn.hideItem("login");
        //show
        mnuMn.showItem("file");
        mnuMn.showItem("view");
        mnuMn.showItem("model");
        mnuMn.showItem("report");
        mnuMn.showItem("chart");
        mnuMn.showItem("help");
    }
}
